<zs-case-phase-nav
  data-phases="vm.getPhases()"
  active-phase="vm.getActivePhase()"
  selected-phase="vm.phaseName()"
  on-phase-click="vm.handlePhaseClick()"
  is-phase-valid="vm.isPhaseValid()"
  pending-changes="vm.getPendingChanges()"
></zs-case-phase-nav>

<div class="phase-body ng-hide" ng-class="{ 'sidebar-collapsed': vm.isSidebarCollapsed() }" ng-show="true">

  <div class="phase-form-container">

    <div class="phase-header-status">

      <button
        type="button"
        class="phase-unlock-button btn btn-secondary"
        ng-show="vm.canUnlock()"
        ng-click="vm.handleUnlockClick()"
        ng-class="{ locked: vm.isLocked() }"
      >
        {{vm.isLocked() ? 'Ontgrendelen' : 'Vergrendelen' }}
      </button>

      <div class="phase-button-wrapper">

        <button
          id="phase-save-button"
          type="button"
          class="phase-button btn-floating"
          zs-disabled="vm.saveButton().disabled"
          ng-click="!vm.saveButton().disabled && vm.saveNow()"
          ng-class="vm.saveButton().classes"
          ng-if="vm.canEdit()"
        >
          <div class="phase-button-inner">
            <div class="phase-button-label">{{vm.saveButton().label}}</div>
          </div>
        </button>

        <button
          id="phase-advance-button"
          type="button"
          class="phase-button phase-advance-button btn-floating"
          zs-disabled="vm.advanceButton().disabled"
          ng-click="!vm.advanceButton().disabled && vm.handleAdvanceClick()"
          ng-class="vm.advanceButton().classes"
          ng-focus="vm.openValidation()"
          ng-blur="vm.closeValidation()"
        >
          <div class="phase-button-inner">
            <zs-icon class="phase-button-icon" icon-type="{{vm.advanceButton().icon}}"></zs-icon>
            <div class="phase-button-label">{{vm.advanceButton().label}}</div>
          </div>
        </button>

      </div>
      <div hidden aria-live="polite" aria-hidden="false">{{vm.advanceButton().ariaLabel}}</div>

      <ul
        class="phase-header-validation-messages"
        zs-position-fixed="{ attachment: 'top right', target: 'bottom right', offset: { x: 0, y: 0 }, reference: vm.advanceButton().reference, updateOn: 'scroll resize watch' }"
        ng-if="vm.isValidationVisible()"
      >
        <span class="phase-header-validation-messages-title">De volgende onderdelen zijn niet of onvolledig ingevuld:</span>
        <div hidden aria-live="polite" aria-hidden="false">{{vm.getListAria()}}</div>
        <li
          class="phase-validation-message"
          ng-repeat="message in vm.getValidationMessages() track by message.name"
          ng-switch="message.type"
          ng-class="message.style"
        >
          <button
            class="phase-validation-button"
            type="button"
            ng-click="message.click()"
            ng-switch-default
            ng-focus="vm.openValidation()"
            ng-blur="vm.closeValidation()"
          >
            <zs-icon icon-type="{{::message.icon}}"></zs-icon>
            <span>{{::message.label}}</span>
          </button>
          <a
            class="phase-validation-button"
            ng-href="{{::message.link}}"
            ng-switch-when="link"
            ng-focus="vm.openValidation()"
            ng-blur="vm.closeValidation()"
            tabindex="0"
          >
            <zs-icon icon-type="{{::message.icon}}"></zs-icon>
            <span>{{::message.label}}</span>
          </a>
        </li>
      </ul>

    </div>

    <div class="phase-form-wrap">

      <div class="phase-form-wrap-inner">

        <div class="phase-header">

          <div class="phase-header-inner">

            <div class="phase-header-title">

              <span class="big-title-blue">{{vm.getPhaseTitle()}}</span>

              <span
                class="big-title-blue phase-deadline"
                ng-if="!!vm.getPhaseDeadline()"
                ng-class="{stalled: vm.isCaseStalled(), missed: vm.isDeadlineMissed()}"
              >
                {{vm.getPhaseDeadline()}}
              </span>

              <div class="phase-header-options">
                <button
                  data-name="{{option.name}}"
                  class="phase-header-option btn-flat btn-round"
                  ng-repeat="option in vm.getPhaseOptions() track by option.name"
                  ng-class="option.classes"
                  ng-click="option.click($event)"
                  zs-tooltip="{{option.label}}"
                >
                  <zs-icon class="phase-header-option-icon" icon-type="{{option.icon}}"></zs-icon>

                </button>
              </div>

            </div>

          </div>

        </div>

        <div class="phase-form">

          <fieldset
            ng-repeat="fieldset in vm.getFieldsets() track by $index"
          >
            <!--
              TODO: remove HTML support as soon as customers are able to
              update their libraries to remove HTML from titles etc
            -->

            <div class="vorm-fieldset-label" ng-bind-html="fieldset.label"></div>
            <div class="vorm-fieldset-description" ng-bind-html="fieldset.description">
            </div>

            <ul class="vorm-field-list">

              <li
                class="vorm-field-item"
                ng-repeat="field in fieldset.fields track by field.id"
                data-name="{{::field.name}}"
                ng-switch="field.type"
              >

                <a name="{{::field.name}}"></a>

                <div
                  ng-switch-default
                >

                  <div class="vorm-field-item-extra">

                    <zs-icon
                      ng-repeat="icon in field.icons track by icon.type"
                      ng-class="icon.classes"
                      icon-type="{{icon.type}}"
                      zs-tooltip="{{icon.tooltip}}"
                      zs-tooltip-options="icon.options"
                    ></zs-icon>

                  </div>

                  <vorm-field
                    data-label="{{field.label}}"
                    add-label="{{field.addLabel}}"
                    data-description="{{field.description}}"
                    data-value="field.value"
                    data-template="field.template"
                    template-data="field.data"
                    on-change="vm.handleChange(field.name, $value)"
                    data-disabled="field.disabled"
                    data-required="field.required"
                    data-pip="field.pip"
                    data-limit="field.limit"
                    model-options="vm.getModelOptions()"
                    data-valid="field.validity"
                    ng-class="field.style"
                    data-compiler="vm.getCompiler()"
                    hide-label="field.hideLabel"
                    confirm-delete="true"
                  >
                  </vorm-field>

                  <zs-case-attribute-update-request
                    ng-if="field.queuable"
                    on-submit="vm.handleAttributeUpdateRequest(field.name, $description)"
                    on-form-open="vm.unlockField(field.name)"
                    on-form-close="vm.lockField(field.name)"
                    is-open="field.unlocked"
                  >
                  </zs-case-attribute-update-request>

                  <zs-pending-change
                    ng-repeat="change in field.pendingChanges"
                    data-change="change"
                    on-accept="vm.handleChangeAccept($change)"
                    on-reject="vm.handleChangeReject($change)"
                    data-disabled="!vm.canAcceptPendingChange()"
                  >
                  </zs-pending-change>

                </div>

                <zs-case-object-mutation-list
                  ng-switch-when="object"
                  object-id="field.data.objectId"
                  object-label="{{::field.label}}"
                  data-capabilities="field.data.capabilities"
                  data-mutations="field.value"
                  data-mutations-loading="vm.mutationsLoading()"
                  data-defaults="vm.getCaseValues()"
                  on-mutation-create="vm.handleMutationCreate(field.name, $type, $label, $objectId, $values)"
                  on-mutation-update="vm.handleMutationUpdate(field.name, $mutation, $label, $values)"
                  on-mutation-remove="vm.handleMutationRemove(field.name, $mutation)"
                  data-disabled="field.disabled"
                >
                </zs-case-object-mutation-list>

                <zs-case-custom-object
                  ng-switch-when="custom_object"
                  case-uuid="vm.getCaseUuid()"
                  data-reload-custom-objects="vm.reloadCustomObjects()"
                  data-custom-objects="field.value"
                  object-type-uuid="field.data.objectTypeUuid"
                  object-action-label="field.data.objectActionLabel"
                  object-label="{{::field.label}}"
                  data-disabled="!vm.canEdit()"
                  data-required="field.required"
                >
                </zs-case-custom-object>

              </li>

            </ul>

          </fieldset>

          <div class="phase-form-empty" ng-show="vm.getFieldsets().length===0">
            Er zijn geen velden beschikbaar in deze fase
          </div>

          <zs-case-result
            data-result="vm.getResult()"
            data-results="vm.getResultOptions()"
            on-result-change="vm.handleResultChange($result)"
            data-can-change="vm.canChangeResult()"
            ng-if="vm.isLastPhase()"
          >
          </zs-case-result>

          <a
            class="skip-area form-back-to-top"
            href=""
            aria-label="Spring naar de knop: '{{vm.advanceButton().label}}'"
            zs-move-focus-to="#phase-advance-button"
          >
            Spring naar de knop: '{{vm.advanceButton().label}}'
          </a>

        </div>

      </div>

    </div>

  </div>

  <zs-case-phase-sidebar
    case-id="vm.getCaseId()"
    case-custom-html-template-name="vm.getCaseCustomHtmlTemplateName()"
    case-uuid="vm.getCaseUuid()"
    data-actions="vm.getActions()"
    data-actions-loading="vm.caseActionsLoading()"
    data-checklist="vm.getChecklist()"
    checklist-resource="vm.checklistResource()"
    data-checklist-loading="vm.checklistsLoading()"
    data-tab="vm.tab()"
    is-collapsed="vm.isSidebarCollapsed($getter)"
    phase-state="vm.getPhaseState()"
    on-action-automatic-toggle="vm.handleActionAutomaticToggle($actionId, $automatic)"
    on-action-untaint="vm.handleActionUntaint($actionId)"
    on-action-trigger="vm.handleActionTrigger($action, $trigger, $data)"
    data-templates="vm.templates()"
    data-subject-relations="vm.subjectRelations()"
    data-requestor="vm.requestor()"
    data-phases="vm.getPhases()"
    selected-milestone="vm.getMilestone()"
    case-documents="vm.caseDocuments()"
    email-template-data="vm.emailTemplateData()"
    can-edit="vm.canEditSidebar()"
  >
  </zs-case-phase-sidebar>

</div>
